import { h } from '../../stencil-public-runtime';
import type { VirtualPositionItem, ColumnTemplateProp, InitialHeaderClick, RangeArea } from "../../types/index";
import { ResizeEvent, ResizeProps } from './resizable.directive';
export type HeaderRenderProps = {
    column: VirtualPositionItem;
    additionalData: any;
    data: ColumnTemplateProp;
    range?: RangeArea | null;
    canResize?: boolean;
    canFilter?: boolean;
    onResize?(e: ResizeEvent): void;
    onClick?(data: InitialHeaderClick): void;
    onDblClick?(data: InitialHeaderClick): void;
} & Partial<Pick<ResizeProps, 'active'>>;
declare const HeaderRenderer: (p: HeaderRenderProps) => ReturnType<typeof h>;
export default HeaderRenderer;
