import { EventEmitter } from '../../stencil-public-runtime';
import type { RowHeaders, ViewPortScrollEvent, ViewportData, ElementScroll } from "../../types/index";
/**
 * Row headers component
 * Visible on the left side of the table
 */
export declare class RevogrRowHeaders {
    /**
     * Header height to setup row headers
     */
    height: number;
    /**
     * Viewport data
     */
    dataPorts: ViewportData[];
    /**
     * Header props
     */
    headerProp: Record<string, any>;
    /**
     * Row class
     */
    rowClass: string;
    /**
     * Enable resize
     */
    resize: boolean;
    /**
     * Row header column
     */
    rowHeaderColumn: RowHeaders;
    /**
     * Additional data to pass to renderer
     */
    additionalData: any;
    /**
     * Prevent rendering until job is done.
     * Can be used for initial rendering performance improvement.
     * When several plugins require initial rendering this will prevent double initial rendering.
     */
    jobsBeforeRender: Promise<any>[];
    /**
     * Scroll viewport
     */
    scrollViewport: EventEmitter<ViewPortScrollEvent>;
    /**
     * Register element to scroll
     */
    elementToScroll: EventEmitter<ElementScroll>;
    render(): any;
}
