/**
 * Autohide scroll for MacOS when scroll is visible only for 1 sec
 */
export declare class AutohideScrollPlugin {
    private element;
    private autohideScrollTimeout;
    constructor(element: HTMLElement);
    /**
     * When scroll size updates set it up for autohide
     */
    setScrollSize(s: number): void;
    /**
     * On each scroll check if it's time to show
     */
    checkScroll({ scrollSize, contentSize, virtualSize, }: {
        scrollSize: number;
        contentSize: number;
        virtualSize: number;
    }): void;
    private show;
    clear(): void;
}
