import { EventEmitter } from '../../stencil-public-runtime';
import type { DimensionType, ViewPortScrollEvent } from "../../types/index";
/**
 * Virtual scroll component
 */
export declare class RevogrScrollVirtual {
    /**
     * Scroll dimension (`X` - `rgCol` or `Y` - `rgRow`)
     */
    dimension: DimensionType;
    /**
     * Dimensions
     */
    realSize: number;
    /**
     * Virtual size
     */
    virtualSize: number;
    /**
     * Client size
     */
    clientSize: number;
    /**
     * Scroll event
     */
    scrollVirtual: EventEmitter<ViewPortScrollEvent>;
    element: HTMLElement;
    private autohideScrollPlugin;
    private scrollSize;
    private localScrollService;
    private localScrollTimer;
    setScroll(e: ViewPortScrollEvent): Promise<void>;
    /**
     * Update if `delta` exists in case we don't know current position or if it's external change
     */
    changeScroll(e: ViewPortScrollEvent): Promise<ViewPortScrollEvent>;
    connectedCallback(): void;
    disconnectedCallback(): void;
    componentWillLoad(): void;
    componentDidRender(): void;
    onScroll(e: MouseEvent): void;
    render(): any;
}
