import type { PluginProviders } from '../types/plugin.types';
import { BasePlugin } from './base.plugin';
/**
 * Automatically adds new rows when pasted data is larger than current rows
 * @event newRows - is triggered when new rows are added. Data of new rows can be filled with default values. If the event is prevented, no rows will be added
 */
export declare class AutoAddRowsPlugin extends BasePlugin {
    constructor(revogrid: HTMLRevoGridElement, providers: PluginProviders);
    handleBeforePasteApply(event: CustomEvent<{
        raw: string;
        parsed: string[][];
        event: ClipboardEvent;
    }>): void;
}
