import { BasePlugin } from '../base.plugin';
import type { CSVFormat, Formatter } from './types';
export * from './csv';
export * from './types';
declare enum ExportTypes {
    csv = "csv"
}
export type ExportFormat = Partial<CSVFormat>;
export declare class ExportFilePlugin extends BasePlugin {
    /** Exports string */
    exportString(options?: ExportFormat, t?: ExportTypes): Promise<string | null>;
    /** Exports Blob */
    exportBlob(options?: ExportFormat, t?: ExportTypes): Promise<Blob | null>;
    /** Export file */
    exportFile(options?: ExportFormat, t?: ExportTypes): Promise<void>;
    /** Blob object */
    getBlob(formatter: Formatter): Promise<Blob | null>;
    private beforeexport;
    private getData;
    private getColPerSource;
    private getGroupHeaders;
    private getSource;
    private formatter;
}
