import { DimensionSettingsState } from "../../types/index";
import type { Observable, PluginSubscribe } from '../../utils';
/**
 * Plugin for trimming
 *
 * 1.a. Retrieves the previous sizes value. Saves the resulting trimmed data as a new sizes value.
 * 1.b. Stores a reference to the trimmed data to prevent further changes.
 * 2. Removes multiple and shifts the data based on the trimmed value.
 */
export declare const trimmedPlugin: (storeService: {
    store: Observable<DimensionSettingsState>;
    setSizes: (k: DimensionSettingsState["sizes"]) => void;
}) => PluginSubscribe<DimensionSettingsState>;
