import { DimensionDataViewport, ItemsToUpdate } from './viewport.helpers';
import { type Observable } from '../../utils';
import type { ViewportState, MultiDimensionType } from "../../types/index";
/**
 * Viewport store class
 */
export declare class ViewportStore {
    readonly type: MultiDimensionType;
    readonly store: Observable<ViewportState>;
    private lastKnownScroll;
    get lastCoordinate(): number;
    set lastCoordinate(value: number);
    constructor(type: MultiDimensionType);
    /**
     * Render viewport based on coordinate
     * It's the main method for draw
     * Use force if you want to re-render viewport
     */
    setViewPortCoordinate(position: number, dimension: DimensionDataViewport, force?: boolean): void;
    /**
     * Set sizes for existing items
     */
    setOriginalSizes(size: number): void;
    getItems(): ItemsToUpdate;
    setViewport(data: Partial<ViewportState>): void;
}
